/*  FFCONJGR.C Conjugate Gradient Algorithm "plug in" training unit */

#ifndef FFCONJGR_C
#define FFCONJGR_C

#include <conio.h>
#include <alloc.h>

#include "ut.h"
#include "cg.h"
#include "ffadv.h"

void conjugate_gradient_training (ff_setup_rec setup,
	   weights_rec weights,training_rec tr_rec,
	   get_data_proc get_network_input_output);

/*  Implementation  */

void conjugate_gradient_training (ff_setup_rec setup,
	   weights_rec weights,training_rec tr_rec,
	   get_data_proc get_network_input_output) {
     /* 'get_network_input_output' is not used.  This paramater is */
     /*  needed to match format of training_proc.  */
     int i,j,k,no_of_weights;
     float err;
     d_vector v_weights;
     g_tr_rec = tr_rec;
     no_of_weights = (setup.no_of_inputs + 1) * setup.no_of_h1_nodes +
	    setup.no_of_h1_nodes * setup.no_of_outputs;
     v_weights = allocate_d_vector (1,no_of_weights);
     network_wts_to_weights (setup,weights,v_weights);
     conjugate_gradient (&ff_objective_fn,&gradient_of_ff_obj_fn,
	  v_weights,no_of_weights,setup.error_threshold,&err);
     weights_to_network_wts (setup,v_weights,weights);
     free_d_vector (v_weights,1);
     clrscr();
     gotoxy (1,4);
     if (write_weights (weights,setup.files.out_wts_file_name,setup)) {
	gotoxy (1,10);
	cprintf ("Weights saved to file: %s",setup.files.out_wts_file_name);
	gotoxy (1,12);
	cputs ("Press key to clear: ");
	getch();
	}
     textmode (LASTMODE);
     return;
     } /* end proc */

#endif