// File FLBRMSET.CPP Set up Turbo Vision interface for
//      Fuzzy Logic Broom Balancing

#ifndef FLBRMSET_CPP
#define FLBRMSET_CPP

#include <conio.h>
#include <string.h>

#include "uisetup.cpp"
extern "C" {
   #include "brm.h"
   #include "flbrm.h"
   }
#include "brmcoll.cpp"

class tflbsetapp : public TSetApp
   {
   public :
     tflbsetapp();
     virtual void setup();
     static TMenuBar *initMenuBar (TRect r );
     static void init_submenus();
     virtual char *save_setup (char *the_file_name);
     virtual char *read_setup (char *the_file_name);
   };

tflbsetapp::tflbsetapp() : TSetApp(),
   TProgInit (&tflbsetapp::initStatusLine,
	      &tflbsetapp::initMenuBar,
	      &tflbsetapp::initDeskTop
	      )
   {
   const int set_zero_theta_tolerance = 4;
   brm_setup_to_collection (&g_brm_setup,system_setup_data.item_collection);
   stpcpy (((tcolor_data_obj *) (system_setup_data.item_collection)->
      at(set_zero_theta_tolerance - 1))->descr_addr,"Zero Force Threshold");
   if (quit_flag == startup) about_dialog();
   }

 void tflbsetapp::init_submenus()
   {
   TSetApp::init_submenus();
   // Skip train and data submenus:
   setup_submenu->next = special_submenu;
   file_submenu->subMenu->items = quit_item;
   file_submenu->subMenu->deflt = quit_item;
   }

TMenuBar *tflbsetapp::initMenuBar ( TRect r )
{
   r.b.y = r.a.y + 1;  //Set bottom line 1 line below top line
   init_submenus();
   return new TMenuBar (r,new TMenu(*about_submenu));
 }

void tflbsetapp::setup()
   {
   list_dialog ("SETUP PARAMETERS","",&system_setup_data,
     MAX_NO_OF_SETUP_ITEMS,&standard_processing);
   return;
   }

char *tflbsetapp::save_setup (char *the_file_name)
   {
   write_record (the_file_name,(void *)&g_brm_setup,sizeof(tbrm_setup_rec));
   return the_file_name;
   }

char *tflbsetapp::read_setup (char *the_file_name)
   {
   read_record (the_file_name,(void *)&g_brm_setup,sizeof(tbrm_setup_rec));
   return the_file_name;
   }

#endif