/* File FLOGIC.H  Fuzzy logic header file  */

#ifndef FLOGIC_H
#define FLOGIC_H

#include "uttypes.h"

#define MAX_NO_OF_INPUTS 5
#define MAX_NO_OF_INP_REGIONS 3
#define MAX_NO_OF_OUTPUT_VALUES 8

typedef enum {regular,left,right} trapz_type;

typedef struct {
   trapz_type tp;
   float a,b,c,d,l_slope,r_slope;
   }  trapezoid;

typedef struct {
   short inp_index[MAX_NO_OF_INPUTS],
	 inp_fuzzy_set[MAX_NO_OF_INPUTS],
	 out_fuzzy_set;
	 }  rule;

typedef struct {
   short allocated;
   trapezoid inp_mem_fns [MAX_NO_OF_INPUTS] [MAX_NO_OF_INP_REGIONS];
   far rule *rules;
   int no_of_inputs,no_of_inp_regions,no_of_rules,no_of_outputs;
   float output_values[MAX_NO_OF_OUTPUT_VALUES];
   } fuzzy_system_rec;

extern fuzzy_system_rec g_fuzzy_system;

/*  File FLPRCS.C */
trapezoid init_trapz (float x1,float x2,float x3,float x4,
   trapz_type typ);
float fuzzy_system (float inputs[],fuzzy_system_rec fl);
void free_fuzzy_rules (fuzzy_system_rec *fz);

/*  File FLFILES.C  */
short read_fuzzy_system (path_str the_file_name,
     int set_in,int set_rgns,int set_rules,int set_out,
     fuzzy_system_rec *fz);
short write_fuzzy_system (path_str the_file_name,fuzzy_system_rec fz);

#endif

