// File UTTYPES.H

// General types and defined constants used by all systems.

#ifndef UTTYPES_H
#define UTTYPES_H

#define MAX_PATH 65

/* Keyboard definitions */
#define BEEP '\x7'
#define BACK_SPACE '\x8'
#define ENTER_KEY '\xD'
#define ESC_KEY '\x1B'
#define SPACE_BAR '\x20'
#define BLOCK_1 '\xB0'          /*  */
#define BLOCK_2 '\xB1'          /*  */
#define BLOCK_3 '\xB2'          /*  */
#define BLOCK_4 '\xDB'          /*  */
#define VERT_BAR '\xB3'         /*  */
 /* the following represent the second code for extended keys */
#define LEFT_ARROW '\x4B'
#define RIGHT_ARROW '\x4D'
#define UP_ARROW '\x48'
#define DOWN_ARROW '\x50'
#define HOME '\x47'
#define END_KEY '\x4F'
#define PAGE_UP '\x49'
#define PAGE_DOWN '\x51'
#define DELETE_KEY '\x53'

enum boolean {FALSE, TRUE};

typedef	char path_str [MAX_PATH];

/*  Vector types  */

typedef unsigned int *ui_vector;
typedef float *f_vector;
typedef double *d_vector;

#endif